%define	name	lighttpd
%define	version	1.4.11
%define	release	%mkrel 2

# Following modules bring no additionnal dependencies
# Other ones go into separate packages
%define base_modules	mod_access.so,mod_accesslog.so,mod_alias.so,mod_cgi.so,mod_dirlisting.so,mod_evhost.so,mod_expire.so,mod_fastcgi.so,mod_indexfile.so,mod_proxy.so,mod_redirect.so,mod_rewrite.so,mod_rrdtool.so,mod_scgi.so,mod_secdownload.so,mod_setenv.so,mod_simple_vhost.so,mod_ssi.so,mod_staticfile.so,mod_status.so,mod_userdir.so,mod_usertrack.so,mod_evasive.so,mod_flv_streaming.so

Name:		%name
Version:	%version
Release:	%release
Summary:	A fast webserver with minimal memory-footprint
Source0:	http://jan.kneschke.de/projects/lighttpd/download/%{name}-%{version}.tar.bz2
Source1:	lighttpd.init
License:	BSD
Group:		System/Servers
URL:		http://jan.kneschke.de/projects/lighttpd/
BuildRequires:	zlib-devel fam-devel mysql-devel memcache-devel lua-devel
BuildRequires:	openssl-devel gdbm-devel bzip2-devel pcre-devel openldap-devel
BuildRequires:	attr-devel libxml2-devel sqlite3-devel
BuildRequires:	autoconf2.5
Requires(post):	rpm-helper
Requires(preun):rpm-helper
Obsoletes:	%name-modules
Provides:	%name-modules
Provides:	webserver
BuildRoot:	%{_tmppath}/%{name}-root

%description
lighttpd is intented to be a frontend for ad-servers which have to deliver
small files concurrently to many connections.

This packages contains the server and base modules :
%(echo %{base_modules} | tr ',' '\n' | sed 's/.so/ /g')

%package mod_auth
Summary:	Authentification module for %{name}
Group:		System/Servers
Requires:	%{name}

%description mod_auth
Authentification module for %{name}

%package mod_cml
Summary:        Authentification module for %{name}
Group:          System/Servers
Requires:	%{name}

%description mod_cml
Authentification module for %{name}

%package mod_compress
Summary:        Authentification module for %{name}
Group:          System/Servers
Requires:	%{name}

%description mod_compress
Authentification module for %{name}

%package mod_mysql_vhost
Summary:        Authentification module for %{name}
Group:          System/Servers
Requires:	%{name}

%description mod_mysql_vhost
Authentification module for %{name}

%package mod_trigger_b4_dl
Summary:        Authentification module for %{name}
Group:          System/Servers
Requires:	%{name}

%description mod_trigger_b4_dl
Authentification module for %{name}

%package mod_webdav
Summary:        Authentification module for %{name}
Group:          System/Servers
Requires:	%{name}

%description mod_webdav
Authentification module for %{name}

%prep
%setup -q

%build
%configure2_5x --libdir=%{_libdir}/%{name}/ \
  --with-mysql\
  --with-ldap\
  --with-attr\
  --with-openssl\
  --with-pcre\
  --with-bzip2\
  --with-fam\
  --with-webdav-props\
  --with-gdbm\
  --with-memcache\
  --with-lua

%make

%install
rm -rf %buildroot
%makeinstall_std

mkdir -p %{buildroot}%{_sysconfdir}/{init.d,sysconfig}
install -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/init.d/lighttpd
install -m 644 doc/sysconfig.lighttpd %{buildroot}%{_sysconfdir}/sysconfig/lighttpd

mkdir -p %{buildroot}%{_sysconfdir}/lighttpd
install -m 644 doc/lighttpd.conf %{buildroot}%{_sysconfdir}/lighttpd

sed -i 's^server.document-root.*$server.document-root = "%{_var}/www/html"' %{buildroot}%{_sysconfdir}/lighttpd/lighttpd.conf
sed -i 's^server.errorlog.*$server.errorlog = "%{_logdir}/lighttpd/error.log"' %{buildroot}%{_sysconfdir}/lighttpd/lighttpd.conf
sed -i 's^accesslog.filename.*$accesslog.filename = "%{_logdir}/lighttpd/access.log"' %{buildroot}%{_sysconfdir}/lighttpd/lighttpd.conf

mkdir -p %{buildroot}%{_logdir}/lighttpd

mkdir -p %{buildroot}%{_var}/www/html

mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/%{name} <<EOF
%{_logdir}/%{name}/*.log {
    size=200M
    rotate 5
    weekly
    missingok
    notifempty
    postrotate
        service %{name} restart
    endscript
}
EOF

rm -f %{buildroot}%{_libdir}/%{name}/*.la

echo %{_libdir}/%{name}/{%{base_modules}} | tr ' ' '\n' > base.list
for i in doc/*.txt
do
	mod=`sed -n 's/^Module: \\(.*\\)$/\\1/p' "$i"`
	if [ -z "$mod" ]
	then
		echo "%doc $i" >> base.list
	else
		if echo "%{base_modules}" | grep "$mod" > /dev/null
		then
			echo "%doc $i" >> base.list
		else
			echo "%doc $i" >> "$mod"
		fi
	fi
done

mkdir -p %buildroot%{_var}/www/html

%clean
rm -rf %buildroot

%post
%_post_service lighttpd

%preun
%_preun_service lighttpd

%files -f base.list
%defattr(-,root,root)
%doc doc/lighttpd.conf doc/lighttpd.user README INSTALL ChangeLog COPYING AUTHORS 
%attr(0755,root,root) %{_sysconfdir}/init.d/lighttpd
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/lighttpd
%dir %{_sysconfdir}/lighttpd/
%config(noreplace) %{_sysconfdir}/lighttpd/*
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name} 
%{_logdir}/lighttpd
%{_mandir}/*/*
%{_sbindir}/*
%{_bindir}/*
%attr(0755,apache,apache) %dir %{_var}/www
%attr(0755,root,root) %dir %{_var}/www/html

%files mod_auth -f mod_auth
%defattr(-,root,root)
%{_libdir}/%{name}/mod_auth.so

%files mod_cml -f mod_cml
%defattr(-,root,root)
%{_libdir}/%{name}/mod_cml.so

%files mod_compress -f mod_compress
%defattr(-,root,root)
%{_libdir}/%{name}/mod_compress.so

%files mod_mysql_vhost -f mod_mysql_vhost
%defattr(-,root,root)
%{_libdir}/%{name}/mod_mysql_vhost.so

%files mod_trigger_b4_dl -f mod_trigger_b4_dl
%defattr(-,root,root)
%{_libdir}/%{name}/mod_trigger_b4_dl.so

%files mod_webdav -f mod_webdav
%defattr(-,root,root)
%{_libdir}/%{name}/mod_webdav.so

%changelog
* Wed Jun 07 2006 Pascal Terjan <pterjan@mandriva.org> 1.4.11-2mdv2007.0
- Don't split base modules as they are needed
- Ship /var/www/html

* Sat Mar 11 2006 Pascal Terjan <pterjan@mandriva.org> 1.4.11-1mdk
- 1.4.11

* Thu Feb 09 2006 Pascal Terjan <pterjan@mandriva.org> 1.4.10-1mdk
- 1.4.10

* Mon Jan 16 2006 Pascal Terjan <pterjan@mandriva.org> 1.4.9-1mdk
- 1.4.9

* Wed Jan 11 2006 Pascal Terjan <pterjan@mandriva.org> 1.4.8-2mdk
- lib64 fix

* Sun Dec 11 2005 Pascal Terjan <pterjan@mandriva.org> 1.4.8-1mdk
- 1.4.7

* Fri Nov 18 2005 Pascal Terjan <pterjan@mandriva.org> 1.4.7-1mdk
- 1.4.7

* Sun Oct 02 2005 Pascal Terjan <pterjan@mandriva.org> 1.4.4-1mdk
- first version
